
module StandaloneIpopt

  using LinearAlgebra, ReverseDiff, ForwardDiff, Ipopt

  export ipopt_optimize, ipopt_nlsolve, Constraints

  const DEF_IPOPT_KWARGS = Dict(:max_iter=>100, :print_level=>5, 
                                :tol=>1e-6, :sb=>"yes")

  include("utils.jl")

  include("forwrapper.jl")

  include("constraints.jl")

  include("derivatives.jl")

  include("constraint_derivatives.jl")

  include("ipopt_optimize.jl")

  include("ipopt_nlsolve.jl")
end

