
# TODO (cg 2022/07/12 13:42): Write another test where the jacobian is actually
# sparse.

# Objective:
obj(x) = x[1]*x[4] * (x[1]+x[2]+x[3]) + x[3]

function constraint_eval(store, x)
  store[1] = prod(x)
  store[2] = sum(abs2, x)
  store
end

# Constraints:
if !(@isdefined ini)
  const constraints = Constraints(2, constraint_eval, [25.0, 40.0], [1e22, 40.0])
  const (b_l, b_u)  = (1.0, 5.0)
  const ini = [1.0, 5.0, 5.0, 1.0]
  const expected_result = [1.000, 4.743, 3.821, 1.379]
end

@testset "AutoFwd" begin
  res_fwd = ipopt_optimize(obj, ini, constraints, box_lower=b_l, box_upper=b_u,
                           print_level=0)
  @test isapprox(res_fwd.minimizer, expected_result, atol=1e-3)
end

@testset "AutoMixed" begin
  res_mix = ipopt_optimize(obj, ini, constraints, box_lower=b_l, box_upper=b_u,
                           derivatives=StandaloneIpopt.AutoMixedDerivatives(obj, 4), 
                           print_level=0)
  @test isapprox(res_mix.minimizer, expected_result, atol=1e-3)
end

